///////////////////////////////////////////////////////////////////////////////
// SquadCloseDoorGoal.uc - SquadCloseDoorGoal class
// this goal is used to organize the Officer's close door behavior

class SquadCloseDoorGoal extends SquadCommandGoal;
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
//
// Variables

// automatically copied to our action
var(parameters) Door	TargetDoor;

///////////////////////////////////////////////////////////////////////////////
//
// Constructors

// Use this constructor
overloaded function construct( AI_Resource r, Pawn inCommandGiver, vector inCommandOrigin, Door inTargetDoor )
{
	super.construct(r, inCommandGiver, inCommandOrigin);

	assert(inTargetDoor != None);
	TargetDoor = inTargetDoor;
}

///////////////////////////////////////////////////////////////////////////////
//
// Accessors

function Door GetDoorBeingUsed()
{
	return TargetDoor;
}

///////////////////////////////////////////////////////////////////////////////
defaultproperties
{
	goalName = "SquadCloseDoor"
}